#include "StdAfx.h"
#include "PopBoxWnd.h"
#include <ShellAPI.h>
//////////////////////////////////////////////////////////////////////////
///

DUI_BEGIN_MESSAGE_MAP(CPopWnd, WindowImplBase)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_CLICK,OnClick)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_ITEMSELECT,OnItemSelect)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_SELECTCHANGED,OnSelectChanged)
DUI_END_MESSAGE_MAP()

CPopWnd::CPopWnd(void)
{
}

CPopWnd::~CPopWnd(void)
{
}

void CPopWnd::OnFinalMessage( HWND hWnd)
{
    __super::OnFinalMessage(hWnd);
    delete this;
}

DuiLib::CDuiString CPopWnd::GetSkinFile()
{
    return _T("popup.xml");
}

LPCTSTR CPopWnd::GetWindowClassName( void ) const
{
    return _T("PopWnd");
}

void CPopWnd::OnClick( TNotifyUI &msg )
{
    CDuiString sName = msg.pSender->GetName();
    sName.MakeLower();

    if( msg.pSender == m_pCloseBtn ) {
        Close(0);
        return; 
    }
    else if( msg.pSender == m_pMinBtn ) { 
        SendMessage(WM_SYSCOMMAND, SC_MINIMIZE, 0); return; }
    else if( msg.pSender == m_pMaxBtn ) { 
        SendMessage(WM_SYSCOMMAND, SC_MAXIMIZE, 0); return; }
    else if( msg.pSender == m_pRestoreBtn ) { 
        SendMessage(WM_SYSCOMMAND, SC_RESTORE, 0); return; }
    else if( msg.pSender == m_pMenuBtn ) {
    }
    else if(sName.CompareNoCase(_T("homepage_btn")) == 0)
    {
        ShellExecute(NULL, _T("open"), _T("https://github.com/qdtroy"), NULL, NULL, SW_SHOW);
    }
}

void CPopWnd::OnSelectChanged( TNotifyUI &msg )
{
    CDuiString sName = msg.pSender->GetName();
    sName.MakeLower();

}

void CPopWnd::OnItemSelect( TNotifyUI &msg )
{
    CDuiString sName = msg.pSender->GetName();
    sName.MakeLower();
}

LRESULT CPopWnd::HandleCustomMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
 {
     bHandled = FALSE;
     return 0;
 }

void CPopWnd::Notify( TNotifyUI &msg )
{
    return WindowImplBase::Notify(msg);
}

LRESULT CPopWnd::OnSysCommand( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
    // 有时会在收到WM_NCDESTROY后收到wParam为SC_CLOSE的WM_SYSCOMMAND
    if( wParam == SC_CLOSE ) {
        ::PostQuitMessage(0L);
        bHandled = TRUE;
        return 0;
    }
    BOOL bZoomed = ::IsZoomed(*this);
    LRESULT lRes = CWindowWnd::HandleMessage(uMsg, wParam, lParam);
    if( ::IsZoomed(*this) != bZoomed ) {
        if( !bZoomed ) {
            CControlUI* pControl = static_cast<CControlUI*>(m_pm.FindControl(_T("maxbtn")));
            if( pControl ) pControl->SetVisible(false);
            pControl = static_cast<CControlUI*>(m_pm.FindControl(_T("restorebtn")));
            if( pControl ) pControl->SetVisible(true);
        }
        else {
            CControlUI* pControl = static_cast<CControlUI*>(m_pm.FindControl(_T("maxbtn")));
            if( pControl ) pControl->SetVisible(true);
            pControl = static_cast<CControlUI*>(m_pm.FindControl(_T("restorebtn")));
            if( pControl ) pControl->SetVisible(false);
        }
    }
    return lRes;
}

void CPopWnd::InitWindow()
{
    m_pCloseBtn = static_cast<CButtonUI*>(m_pm.FindControl(_T("closebtn")));
    m_pMaxBtn = static_cast<CButtonUI*>(m_pm.FindControl(_T("maxbtn")));
    m_pRestoreBtn = static_cast<CButtonUI*>(m_pm.FindControl(_T("restorebtn")));
    m_pMinBtn = static_cast<CButtonUI*>(m_pm.FindControl(_T("minbtn")));
    m_pMenuBtn = static_cast<CButtonUI*>(m_pm.FindControl(_T("menubtn")));
}
