#pragma once
#include "UIlib.h"
using namespace DuiLib;
//////////////////////////////////////////////////////////////////////////
///

class CPopWnd : public WindowImplBase
{
public:
    CPopWnd(void);
    ~CPopWnd(void);

public:
    virtual void OnFinalMessage( HWND );
    virtual CDuiString GetSkinFile();
    virtual LPCTSTR GetWindowClassName( void ) const;
    virtual void Notify( TNotifyUI &msg );
    virtual void InitWindow();

    DUI_DECLARE_MESSAGE_MAP()
    virtual void OnClick(TNotifyUI& msg);
    virtual void OnSelectChanged( TNotifyUI &msg );
    virtual void OnItemSelect( TNotifyUI &msg );

    virtual LRESULT OnSysCommand( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );
    LRESULT HandleCustomMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    virtual LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM /*lParam*/, bool& /*bHandled*/)
    {
        if (uMsg == WM_KEYDOWN)
        {
            switch (wParam)
            {
            case VK_RETURN:
            case VK_ESCAPE:
                return ResponseDefaultKeyEvent(wParam);
            default:
                break;
            }
        }
        return FALSE;
    }
private:
    CButtonUI* m_pCloseBtn;
    CButtonUI* m_pMaxBtn;
    CButtonUI* m_pRestoreBtn;
    CButtonUI* m_pMinBtn;
    CButtonUI* m_pMenuBtn;
};
